function [f,g] = fun(x)
    n = length(x);
    f = norm(x(1:n-2).*x(2:n-1).*x(3:n))^2-1;
    if argn(1)>1
        g = zeros(n,1);
        k = 3:n-2;
        g(1)   = 2*x(1)*x(2)^2*x(3)^2;
        g(2)   = 2*(x(2)*x(3)^2*x(4)^2+x(1)^2*x(2)*x(3)^2);
        g(k)   = 2*(x(k).*x(k+1).^2.*x(k+2).^2+x(k-1).^2.*x(k).*x(k+1).^2+x(k-2).^2.*x(k-1).^2.*x(k))
        g(n-1) = 2*(x(n-3)^2*x(n-2)^2*x(n-1)+x(n-2)^2*x(n-1)*x(n)^2); 
        g(n)   = 2*x(n-2)^2*x(n-1)^2*x(n);
        g=g+2*x;
    end
endfunction

n=10;
problem = struct();
problem.objective = fun;
problem.x0 = rand(n,1);

opt = optimoptions("fmincon");
opt.SpecifyObjectiveGradient = %t;
opt.Display = "iter";
//opt.CheckGradients = %t;

problem.options = opt;

[x,fval,exitflag,output] = fmincon(problem);
